
(* for translation of probes (Compose.instance) [see if could use ENV instead, and zap Arch] *)
(* was formerly used for printing arch too, but -arch now superseded by -json *)

structure Arch = struct

datatype arch =
	 Leaf of string * (string * string) list * string list  (* process instance, with shvar map (for probes) and states *)
       | Node of string * arch list                                     (* component, with attached instances *)

val ATREE = ref ([] : arch list);

(* s = name, r = shared vars map, stl = state list *)
fun push_leaf s r stl =
    ATREE := Leaf (s,r,stl) :: !ATREE;

(* n = name, a = arity *)
fun push_node n a =
    let fun pop 0 l = l
	  | pop n l = let val h::t = !ATREE in ATREE := t; pop (n-1) (h::l) end
    in ATREE := Node (n, pop a []) :: !ATREE
    end;

val ANON = ref 0;
fun anon () =
    (ANON := 1 + !ANON; "_ANON_"^Int.toString (!ANON));

fun push_anon n a =
    let fun pop 0 l = l
	  | pop n l = let val h::t = !ATREE in ATREE := t; pop (n-1) (h::l) end
    in ATREE := Node (n,pop a []) :: !ATREE
    end;

fun instance path m =
    let fun find [] (Node (n,sl)) = (n,[],[])
	  | find (h::t) (Node (n,sl)) = find t (List.nth (sl,h-1))
	  | find _ (Leaf (n,al,stl)) = (n,al,stl)
	val SOME m' = List.find (fn Node (x,_) => x=m) (!ATREE) 
    in find path m'
    end;

end;




